<?php
// This results in an error.
// The output above is before the header() call
header('Try: start.com');

function is_valid_domain_name($domain_name)
{
    return (preg_match("/^([a-z\d](-*[a-z\d])*)(\.([a-z\d](-*[a-z\d])*))*$/i", $domain_name) //valid chars check
            && preg_match("/^.{1,253}$/", $domain_name) //overall length check
            && preg_match("/^[^\.]{1,63}(\.[^\.]{1,63})*$/", $domain_name)   ); //length of each label
}



function testDomain($domainName) {
   header("X-Test-Domain: $domainName");
   $answer = false;

   $dblocation = dirname(__FILE__).'/sqlite_db/blacklist.db';
   $db = new SQLite3($dblocation,SQLITE3_OPEN_READWRITE | SQLITE3_OPEN_CREATE);
#   $db = new SQLite3($dblocation);


   if(file_exists($dblocation)) {
   $res = $db->query("CREATE TABLE IF NOT EXISTS blacklist (domain TEXT NOT NULL UNIQUE) ");

       $result = $db->query("SELECT * FROM blacklist WHERE (domain LIKE '%." . $domainName . "' ) OR  ( domain = '" . $domainName . "')");
       $rows = $result->fetchArray();

       if ( $rows == false) {
         $answer = false;
       } else {
         $answer = true;
       }

     
   }
   $db->close();
   return $answer;
}


$allow = true;

if ( isset($_GET['host']) && is_valid_domain_name($_GET['host'])) {
	if ( testDomain($_GET['host']) ) {
		header('X-Vote: BLOCK');
		$allow = false;
	}
}


if ( isset($_GET['url']) && !isset($_GET['host'])) {
	$link = parse_url($_GET['url']);
#	echo var_dump($link);
	if ( testDomain($link['host']) ) {
		header('X-Vote: BLOCK');
		$allow = false;
	}
}

if ( $allow ) {
	header('X-Test-Vote: ALLOW');
	header('X-No-Vote: 1');
}

?>
